; 

    .686p                     ; maximum processor model
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive

    utoa PROTO :DWORD,:DWORD

    .code                     ; code section

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

utoa proc src:DWORD, lpdest:DWORD

  ; ----------------------------------------------------------------------
  ; This is a modified version of an algorithm written by Ray Filiatreault
  ; ----------------------------------------------------------------------

    mov eax, [esp+4]            ; src
    mov ecx, [esp+8]            ; lpdest             ; buffer address

    push esi
    push ecx                    ; save dest address

    sub ecx, 1
    mov esi, 0CCCCCCCDh         ; "magic number" multiplier for division by 10
    mov DWORD PTR [esp+16], 10

  @@:
    mul esi                     ; multiply by magic number
    shrd eax, edx, 3            ; binary fractional "remainder" back in EAX
    shr edx, 3                  ; EDX = quotient
    add eax, 1                  ; precaution against occasional "underflow"
    mov [esp+12], edx           ; save current quotient for next division
    mul DWORD PTR [esp+16]      ; x10 gets "decimal" remainder into EDX
    add ecx, 1                  ; increment digit in buffer
    add dl, 30h                 ; convert remainder to ascii
    mov [ecx], dl               ; insert it into buffer
    mov eax, [esp+12]           ; retrieve current quotient
    test eax, eax               ; test if done
    jnz @B                      ; continue if not done

    mov byte ptr [ecx+1], 0     ; terminate the string
    mov esi, [esp]              ; copy the dest address into ESI

  @@:
    movzx eax, BYTE PTR [esi]   ; reverse the string
    movzx edx, BYTE PTR [ecx]
    mov [esi], dl
    mov [ecx], al
    add esi, 1
    sub ecx, 1
    cmp esi, ecx
    jb @B

    pop eax                     ; restore and return dest address
    pop esi

    ret 8

utoa endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end
